VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FormResize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Private Type Rect
     WidthP As Single
     HeigthP As Single
     TopP As Single
     LeftP As Single
End Type

Private Type ControlInfo
     Cont As Control
     measures As Rect
End Type

Dim fForm As Form
Dim AllControls() As ControlInfo

Public Property Let Form(F As Form)
     Set fForm = F
     Call GetAllPositions
End Property

Public Property Get Form() As Form
     Set Form = fForm
End Property

Public Sub Resize()
     Dim SW As Single
     Dim SH As Single
     SW = Me.Form.ScaleWidth
     SH = Me.Form.ScaleHeight
     
     Dim i As Integer
     For i = 0 To UBound(AllControls)
          With AllControls(i)
               .Cont.Left = (SW * .measures.LeftP) / 100
               .Cont.Top = (SH * .measures.TopP) / 100
               .Cont.Width = (SW * .measures.WidthP) / 100
               .Cont.Height = (SH * .measures.HeigthP) / 100
          End With
     Next i
End Sub

Private Sub GetAllPositions()
    Dim c As Control
    For Each c In Me.Form.Controls
        If Not (TypeOf c Is Toolbar Or TypeOf c Is ImageList) Then
            Call AddControl(c, c.Left, c.Top, c.Width, c.Height)
        End If
    Next c
End Sub

Private Sub AddControl(ByRef Cont As Control, ByVal X As Single, _
    ByVal Y As Single, ByVal W As Single, ByVal H As Single)
    
     Dim pos As Integer
     On Error Resume Next
     pos = UBound(AllControls) + 1
     If Err Then pos = 0
     On Error GoTo 0
     
     ReDim Preserve AllControls(pos)
     
     Dim SW As Single
     Dim SH As Single
     SW = Me.Form.ScaleWidth
     SH = Me.Form.ScaleHeight
     
     With AllControls(pos)
          Set .Cont = Cont
          With .measures
               .LeftP = (X * 100) / SW
               .TopP = (Y * 100) / SH
               .WidthP = (W * 100) / SW
               .HeigthP = (H * 100) / SH
          End With
     End With
End Sub
